local createobjects = {}

local function intGetNextAgentID()
-- find the highest ID and return the one after that

	local highestID = 0
	for k, v in ipairs(Agents) do
		if v.ID ~= nil then
			if v.ID > highestID then
				highestID = v.ID
			end
		end		
	end
	return highestID + 1
	
end

function createobjects.CreateAgent()
	-- initialises agents and bots
	-- Agents (non-physics)
	bot = {}
	bot.ID = intGetNextAgentID()
	bot.health = 100
	bot.happiness = 50
	bot.wealth = 100
	bot.job = nil
	bot.viralload = 0				-- %
	bot.virusdetected = false		-- has the virus been detected
	bot.maxviralload = 0
	bot.shedding = 0				-- %
	bot.red = 1
	bot.green = 1
	bot.blue = 1
	bot.targetx = nil
	bot.targety = nil
	bot.targetzone = nil
	bot.currenttask = nil
	bot.currenttasklabel = nil
	bot.nexttasktimer = 2

	bot.isselected = false		-- skillset

	-- physics stuff
	x = love.math.random(100, gintScreenWidth - 100)
	y = love.math.random(100, gintScreenHeight - 100)
	bot.body = love.physics.newBody(world,x,y,"dynamic")
	bot.body:setLinearDamping(0.5)
	bot.body:setMass(love.math.random(60,120))
	bot.shape = love.physics.newCircleShape(gintAgentRadius)
	bot.fixture = love.physics.newFixture(bot.body, bot.shape, 1)		-- the 1 is the density
	bot.fixture:setRestitution(1.5)
	bot.fixture:setSensor(false)	-- false = bounce
	bot.fixture:setUserData(bot.ID)
	
	bot.linearvelocityx = 0
	bot.linearvelocityy = 0
	
	table.insert(Agents, bot)

end

function createobjects.CreateWorld(Zne)
	-- 1440 x 900

	-- hospital
	myzone = {}
	myzone.ID = #Zne + 1	--**
	myzone.x = 1340
	myzone.y = 600
	myzone.width = 100
	myzone.height = 300
	myzone.zonetype = enum.zonetypeHeal
	table.insert(Zne, myzone)	
	
	-- quarantine
	
	
	
	-- home iso
	myzone = {}
	myzone.ID = #Zne + 1	--**
	myzone.x = nil
	myzone.y = nil
	myzone.width = nil
	myzone.height = nil
	myzone.zonetype = enum.zonetypeHouseIso
	table.insert(Zne, myzone)	
	
	-- general lock down
	
	
	
	
	
end



return createobjects