local drawobjects = {}

function drawobjects.DrawWorld()

	for k,v in ipairs(Zones) do
		if v.zonetype == enum.zonetypeHeal then
			love.graphics.setColor(0,1,0,1)
			love.graphics.rectangle("line", HospitalX,HospitalY,HospitalWidth,HospitalHeight)
			love.graphics.print("Hospital", HospitalX + 2, HospitalY + 20)
		end
		if v.zonetype == enum.zonetypeHouseIso then
			love.graphics.setColor(104/255,99/255,1,1)
			love.graphics.rectangle("line", IsoX,IsoY,IsoWidth,IsoHeight)
			love.graphics.print("Home Iso", IsoX + 2, IsoY + 20)
		end		
		

	end
	
	if gbolPaused then
		love.graphics.setColor(1,1,1,1)
		love.graphics.print("Paused", 950, 550)
	end
end

function drawobjects.DrawAgents(agt)
-- agt = Agents

	for k, v in ipairs(agt) do
	
		local x = v.body:getX()
		local y = v.body:getY()
	
		love.graphics.setColor(v.red,v.green,v.blue,1)
		
		if v.viralload == 0 then
			love.graphics.circle("fill", x,y, gintAgentRadius )		
		else
			love.graphics.rectangle("fill", x-gintAgentRadius, y-gintAgentRadius ,gintAgentRadius * 2, gintAgentRadius * 2)
		end
		
		if v.isselected then
			love.graphics.setColor(1,0,0,0.5)
			love.graphics.circle("fill", x,y, gintAgentRadius / 2 )			
		end
		
		-- display their ID
		-- love.graphics.setColor(219/255,45/255,45/255,1)
		-- love.graphics.print(v.ID,x-5,y-7 )			-- the -5 is to centre the text
		
		if gbolShowData then
			-- display meta-data for debugging
			local tmpstr = ""
			tmpstr = tmpstr .. "Action: "
			if v.currenttasklabel ~= nil then
				tmpstr = tmpstr .. v.currenttasklabel
			end
			tmpstr = tmpstr .. "\n"			
	
			if v.health > 90 and v.viralload == 0 and v.shedding == 0 then
				-- do nothing
			else
				love.graphics.setColor(1,1,1,1)
				tmpstr = tmpstr .. "Health: " .. cf.round(v.health,0) .. "\n"
				
				tmpstr = tmpstr .. "Viral load: " .. cf.round(v.viralload,0) .. "\n"
				tmpstr = tmpstr .. "Viral shedding: " .. cf.round(v.shedding,0) .. "\n"
				tmpstr = tmpstr .. "Detected: " .. tostring(v.virusdetected) .. "\n"
			end
			love.graphics.print(tmpstr, x+10, y - 3)
		end

	end

end     

function drawobjects.DrawStats()

	local tmpstr = ""
	
	tmpstr = "Transactions/sec: " .. cf.round(gintTransactions/gfltTotalTime,1) .. "\n"
	tmpstr = tmpstr .. "Avg wealth: " .. cf.round(gintTotalWealth/#Agents,1) .. "\n"
	tmpstr = tmpstr .. "Deaths: " .. gintDeaths .. "\n"
	-- tmpstr = tmpstr .. "Known cases: " .. gintCurrentCases .. "\n"
	
	-- tmpstr = tmpstr .. "Avail. food: " .. cf.round(gstatFoodStock,0) .. "\n"
	
	
	love.graphics.setColor(1,1,1,1)
	love.graphics.print(tmpstr, 10,10)

end

function drawobjects.DrawPriorities()
  
  	local tmpstr = ""
	
	tmpstr = "Eat food #1: " .. cf.round(tree.child[4].priority(Agents[1]),0) .. "\n"
	-- tmpstr = tmpstr .. "Eat water: " .. tree.child[1].child[2].priority .. "\n"
	-- tmpstr = tmpstr .. "Rest: " .. tree.child[1].priority .. "\n"
	-- tmpstr = tmpstr .. "Work: " .. tree.child[2].priority .. "\n"
	
	love.graphics.setColor(1,1,1,1)
	love.graphics.print(tmpstr, 10,160)
    
 end
 
 function drawobjects.DrawInstructions()
 
	local tmpstr = ""
	
	tmpstr = tmpstr .. "Alt = toggle stats" .. "\n"
	-- tmpstr = tmpstr .. "'F' to make a farmer" .. "\n"
	-- tmpstr = tmpstr .. "'H' to make a healer" .. "\n"
	-- tmpstr = tmpstr .. "'J' to make a lumberjack" .. "\n"
	
	tmpstr = tmpstr .. "<space> to pause" .. "\n"
	
	love.graphics.setColor(1,1,1,1)
	love.graphics.print(tmpstr, 10,200)
 
 
 end


return drawobjects